unit DBTrackTarget_DTEdit;

{<
  DBTrackTarget_DTEdit is design time dialog used by DBTrackTarget component.

  Updated version compatible with Delphi2010+.
  Full functional demo.
  @author(Rosinsky Software - <http://www.rosinsky.cz/delphi>)
  @created(May 2006)
  @lastmod(Jan 2013)
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, db, ComCtrls;

type
  TDBTrackTarget_DTEditForm = class(TForm)
    pc: TPageControl;
    tsCol: TTabSheet;
    cbDateTime: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    cbUser: TComboBox;
    Label4: TLabel;
    cbAction: TComboBox;
    Label5: TLabel;
    cbTableName: TComboBox;
    Label6: TLabel;
    cbKeyValue: TComboBox;
    Label7: TLabel;
    cbChanges: TComboBox;
    Label8: TLabel;
    cbMemo: TComboBox;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label14: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    cbSpecial: TComboBox;
    Label18: TLabel;
    btClose: TButton;
    procedure FormShow(Sender: TObject);
    procedure btCloseClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    FFields: TStrings;
    procedure LoadProps;
    procedure SetProps;
  public
  end;

function ShowDBTrackTargetEditor(Component: TComponent): boolean;

implementation

{$R *.dfm}

uses TypInfo, rtool, rdlg, rdbtool;

function ShowDBTrackTargetEditor(Component: TComponent): boolean;
var F: TDBTrackTarget_DTEditForm;
    DS: TDataSet;
begin
  Result:=true;
  F:=TDBTrackTarget_DTEditForm.Create(Application);
  try
    F.Caption:=Component.Name;
    F.FFields.Clear;
    try
      DS:=GetObjectProp(Component,'TargetDataSet') as TDataSet;
      GetFldList(DS,F.FFields,[fdAllField]);
    except
    end;
    F.cbDateTime.Text:=GetStrProp(Component,'FieldDateTime');
    F.cbDateTime.Items.Assign(F.FFields);
    F.cbUser.Text:=GetStrProp(Component,'FieldUser');
    F.cbUser.Items.Assign(F.FFields);
    F.cbAction.Text:=GetStrProp(Component,'FieldAction');
    F.cbAction.Items.Assign(F.FFields);
    F.cbTableName.Text:=GetStrProp(Component,'FieldTableName');
    F.cbTableName.Items.Assign(F.FFields);
    F.cbKeyValue.Text:=GetStrProp(Component,'FieldKeyValue');
    F.cbKeyValue.Items.Assign(F.FFields);
    F.cbChanges.Text:=GetStrProp(Component,'FieldChanges');
    F.cbChanges.Items.Assign(F.FFields);
    F.cbMemo.Text:=GetStrProp(Component,'FieldMemo');
    F.cbMemo.Items.Assign(F.FFields);
    F.cbSpecial.Text:=GetStrProp(Component,'FieldSpecial');
    F.cbSpecial.Items.Assign(F.FFields);

    F.ShowModal;

    SetStrProp(Component,'FieldDateTime',F.cbDateTime.Text);
    SetStrProp(Component,'FieldUser',F.cbUser.Text);
    SetStrProp(Component,'FieldAction',F.cbAction.Text);
    SetStrProp(Component,'FieldTableName',F.cbTableName.Text);
    SetStrProp(Component,'FieldKeyValue',F.cbKeyValue.Text);
    SetStrProp(Component,'FieldChanges',F.cbChanges.Text);
    SetStrProp(Component,'FieldMemo',F.cbMemo.Text);
    SetStrProp(Component,'FieldSpecial',F.cbSpecial.Text);
  finally
    F.Free;
  end;
end;

procedure TDBTrackTarget_DTEditForm.FormCreate(Sender: TObject);
begin
  FFields:=TStringList.Create;
end;

procedure TDBTrackTarget_DTEditForm.FormDestroy(Sender: TObject);
begin
  FFields.Free;
end;

procedure TDBTrackTarget_DTEditForm.FormShow(Sender: TObject);
begin
  pc.ActivePageIndex:=0;
  LoadProps;
end;

procedure TDBTrackTarget_DTEditForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  SetProps;
end;

procedure TDBTrackTarget_DTEditForm.btCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TDBTrackTarget_DTEditForm.LoadProps;
begin
  ;
end;

procedure TDBTrackTarget_DTEditForm.SetProps;
begin
  ;
end;

end.
