unit RosiCompDesignEditors_Reg;

{<
  rComp_DTReg is unit for registration of design time dialog
  for Rosi components.

  Updated version compatible with Delphi2010+.
  Full functional demo.
  @author(Rosinsky Software - <http://www.rosinsky.cz/delphi>)
  @created(May 2006)
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ShlObj, DesignIntf, DesignEditors,
  PropSaveMain, rImprovedComps;

{ @exclude }
type
  TPropSave_Editor = class(TComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

  TrGroupBox_Editor = class(TComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

procedure Register;

implementation

uses PropSave_DTEdit, rGroupBox_DTEdit;

procedure Register;
begin
  ForceDemandLoadState(dlDisable);
  RegisterComponentEditor(TCustomPropSave, TPropSave_Editor);
  RegisterComponentEditor(TPropSaveMain, TPropSave_Editor);
  RegisterComponentEditor(TrGroupBox, TrGroupBox_Editor);
end;

function TPropSave_Editor.GetVerbCount: Integer;
begin
  Result:= inherited GetVerbCount + 1;
end;

function TPropSave_Editor.GetVerb(Index: Integer): string;
var
  I: Integer;
begin
  I:= inherited GetVerbCount;
  if Index < I then
    Result:= inherited GetVerb(Index)
  else
    case Index - I of
      0:
        Result:='PropertySaver Editor';
    end;
end;

procedure TPropSave_Editor.ExecuteVerb(Index: Integer);
var
  I: Integer;
begin
  I:= inherited GetVerbCount;
  if Index < I then
    inherited
  else
  begin
    case Index - I of
      0:
        if ShowPropertySaverEditor(Component) then
          Designer.Modified;
    end;
  end;
end;

function TrGroupBox_Editor.GetVerbCount: Integer;
begin
  Result:= inherited GetVerbCount + 1;
end;

function TrGroupBox_Editor.GetVerb(Index: Integer): string;
var
  I: Integer;
begin
  I:= inherited GetVerbCount;
  if Index < I then
    Result:= inherited GetVerb(Index)
  else
    case Index - I of
      0:
        Result:='rGroupBox Editor';
    end;
end;

procedure TrGroupBox_Editor.ExecuteVerb(Index: Integer);
var
  I: Integer;
begin
  I:= inherited GetVerbCount;
  if Index < I then
    inherited
  else
  begin
    case Index - I of
      0:
        if ShowrGroupBoxEditor(Component) then
          Designer.Modified;
    end;
  end;
end;

end.
